class Mover
{
  ArrayList<PVector> positions;
  ArrayList<Float> rotations;

  float rot = 0;
  
  int type = 0;
  PImage skin;
  
  boolean state = false;

  Mover()
  {
    positions = new ArrayList();
    rotations = new ArrayList();
    
    skin = actors.get(type);
  }

  void update()
  {
     displayLines();
     //displayVector();
     displayImage();
  }
  
  void displayLines()
  {
    if (positions.size() > 1) {
      stroke(0, 50);
      noFill();
      beginShape(LINES);
      for (int k = 1; k < positions.size(); k++) {
        PVector l = positions.get(k-1);
        PVector c = positions.get(k);
        vertex(l.x, l.y);
        vertex(c.x, c.y);
      }
      endShape();
    }
  }
  
  void displayVector()
  {
    pushMatrix();
    int index = constrain(frame, 0, positions.size()-1);
    PVector cp = positions.get(index);
    Float cr = rotations.get(index);
    translate(cp.x, cp.y);
    rot = lerpAng(rot, cr, 1);
    rotate(rot);
    noStroke();
    fill(255, 0, 0, 150);
    triangle(0, 25, 15, -15, -15, -15);
    popMatrix();
  }
  
  void displayImage()
  {
    if (positions.size() > 0) {
      color c = (state) ? color(255,0,0) : color(0);
      
      pushMatrix();
      int index = constrain(frame, 0, positions.size()-1);
      PVector cp = positions.get(index);
      Float cr = rotations.get(index);
      translate(cp.x, cp.y);
      rot = lerpAng(rot, cr, 1);
      rotate(rot);
      tint(c);
      image(actors.get(type), -actors.get(type).width/2, -actors.get(type).height/2);
      popMatrix();
    }
  }

  void reset()
  {
    positions.clear();
    rotations.clear();
    
    state = false;
    rot = 0;
    type = 0;
    skin = actors.get(type);
  }

  void drag()
  {
    PVector m = new PVector(mouseX, mouseY);
    vec = PVector.sub(ori, m);
    dang = atan2(vec.y, vec.x);
  }
}

