package ro.tibor.processing.gameJam;

import processing.core.PApplet;
import ddf.minim.AudioPlayer;
import ddf.minim.AudioSample;
import ddf.minim.Minim;

public class AudioManager {
	
	private Minim minim;
	private AudioPlayer audioPlayer;
	private AudioSample deathSample;
	private AudioSample levelOverSample;
	
	private PApplet p;

	
	private static AudioManager instance = null;

	protected AudioManager() {
		// Exists only to defeat instantiation.
	}

	public static AudioManager getInstance() {
		if (instance == null) {
			instance = new AudioManager();
		}
		return instance;
	}
	
	public void setP(PApplet p)
	{
		this.p = p;
		minim = new Minim(p);
		audioPlayer = minim.loadFile("sounds/projector.mp3");
		audioPlayer.setGain(-34.0f);
		audioPlayer.loop();
		
		deathSample = minim.loadSample("sounds/death.mp3");
		levelOverSample = minim.loadSample("sounds/levelOver.mp3");
	}
	
	public void playDeathSound()
	{
		deathSample.trigger();
	}
	
	public void playLevelOverSound()
	{
		levelOverSample.trigger();
	}
}