package ro.tibor.processing.gameJam;


import ddf.minim.AudioPlayer;
import ddf.minim.AudioSample;
import ddf.minim.Minim;
import processing.core.PApplet;
import processing.core.PImage;
import processing.opengl.PShader;


public class FritzSketch extends PApplet
{
	PShader shader;
	
	private static final long serialVersionUID = 1L;
	
	Level level;
	
	boolean showingSplash;
	PImage spashScreen;
	int clickTime = 0;
	
	public void setup()
	{
		size(1024, 768, P3D);
		frameRate(60);
		imageMode(CENTER);
		
		shader = loadShader("blur.glsl"); 
		
		AudioManager.getInstance().setP(this);
		
		showingSplash = true;
		spashScreen = loadImage("menu.png");
		
		LevelManager.getInstance().setPApplet(this);
	}
	
	public void draw()
	{
		background(255);
		
		if (showingSplash)
		{
			image(spashScreen, width/2, height/2, width, height);
		}
		else
		{
		LevelManager.getInstance().currentLevel.update();
		LevelManager.getInstance().currentLevel.draw();
		}
		filter(shader); 
	}

	public void mouseClicked()
	{
		if (showingSplash)
		{
			showingSplash = false;
		}
		else
		{
			LevelManager.getInstance().currentLevel.click();
		}
	}
	
	public static void main(String _args[]) {
		PApplet.main(new String[] { ro.tibor.processing.gameJam.FritzSketch.class.getName() });
	}
}
