package ro.tibor.processing.gameJam;

import processing.core.PApplet;

public class LevelManager {

	private static LevelManager instance = null;

	public Level currentLevel;
	private int currentLevelIndex;
	private String[] arrayLevelNames = { "levels/level1.json", 
			"levels/level2.json", 
			"levels/level3.json",  
			"levels/level5.json", 
			"levels/level7.json", 
			"levels/level8.json", 
			"levels/level9.json",
			"levels/level4.json",
			"levels/level6.json" 
			};
	
	private PApplet p;
	
	public void setPApplet(PApplet p)
	{
		this.p = p;
		currentLevel = new Level(p, arrayLevelNames[currentLevelIndex]);
		currentLevel.setCurrentLevelIndex(currentLevelIndex + 1);
	}
	
	protected LevelManager() 
	{
		currentLevelIndex = 0;
	}
	
	public static LevelManager getInstance() 
	{
		if (instance == null) {
			instance = new LevelManager();
		}
		return instance;
	}
	
	public void repeatLevel()
	{
		currentLevel = new Level(p, arrayLevelNames[currentLevelIndex]);
		currentLevel.setCurrentLevelIndex(currentLevelIndex + 1) ;
	}
	
	public void nextLevel()
	{
		currentLevelIndex = (currentLevelIndex + 1) % arrayLevelNames.length;
		currentLevel = new Level(p, arrayLevelNames[currentLevelIndex]);
		currentLevel.setCurrentLevelIndex(currentLevelIndex + 1) ;
	}
	
}