package ro.tibor.processing.gameJam;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Timer;

import processing.core.PApplet;
import processing.core.PImage;

public class LevelStateHandlerNow extends LevelStateHandler
{
	private int timeRemainingInSeconds;
	private PImage backgroundImage;
	
	private int frameLenght;
	private int remainingFrames;
	private int startFrame;
	private boolean isOver;
	
	public LevelStateHandlerNow(PApplet p, Level level, int frameLength) 
	{
		super(p, level);
		timeRemainingInSeconds = timeInMilis / 1000;
		backgroundImage = p.loadImage("present.png");
		this.frameLenght = frameLength;
		isOver = false;
	}
	
	public void start()
	{	
		isOver = false;
		this.startFrame = p.frameCount;

		for (Mover m: level.listMovers)
		{
			m.stateMachine.next();
		}	
	}
	
	boolean isGameWon()
	{
		boolean won = true;
		
		for (Mover m: level.listMovers)
		{
			if ( m.diesInTheEnd != m.isDead )
			{
				won = false;
				break;
			}
		}
		
		return won;
	}
	
	void timeOver()
	{
		System.out.println("Level win " + isGameWon());
		level.isWon = isGameWon();
		onEnd(this);		
	}
	
	@Override
	public void update() 
	{
		// TODO Auto-generated method stub	
	}
	
	public void click()
	{
		for (Mover m: level.listMovers)
		{
			m.click();
		}		
	}

	@Override
	public void draw() {
		super.draw();
		
		p.fill(0);
		int remainingFrames = startFrame + frameLenght - p.frameCount;
		p.rect(0, 0, PApplet.map( remainingFrames, 0, frameLenght ,0, p.width), p.height * 0.025f);
		
		if (remainingFrames == 0 && !isOver)
		{
			timeOver();
			isOver = true;
		}
		
		p.image(backgroundImage, p.width / 2, p.height / 2, p.width, p.height);
		
		for (Mover m : level.listMovers) 
		{
			m.update();
			m.draw();
		}
	}
}
