package ro.tibor.processing.gameJam;

import java.util.ArrayList;
import java.util.List;

import processing.core.PApplet;
import processing.core.PImage;
import processing.core.PVector;
import ro.tibor.processing.gameJam.stateMachine.MoverStateMachine;

public class Mover {
	
	/****************************************
	 *				Attributes
	 ****************************************/
	private PApplet p;

	public List<Mover> listMovers;
	public List<PImage> images;

	public PImage startImage;
	public PImage endImage;

	public PVector position;
	public PVector delta;

	public float rotation;

	boolean isKiller;


	public float trigger;
	
	boolean isPlayer;
	Pointer pointer;
		
	boolean hasAttacked = false;
	
	public MoverStateMachine stateMachine;	
	
	public boolean isFritz;
	
	public boolean diesInTheEnd;
	public boolean isDead;
	
	public ArrayList<PVector> listPositions;
	public ArrayList<Float> listRotations;
	
	public int triggerIndex;
	
	public boolean shouldDrawPointer;
	
	/****************************************
	 *    			Constructor
	 ****************************************/
	
	Mover(PApplet p, ArrayList<Mover> listMovers, ArrayList<PImage> images,
			PVector position, float rotation, boolean diesInTheEnd,
			boolean isFritz, int triggerIndex) 
			{
		this(p, listMovers, images, position, rotation, diesInTheEnd, isFritz, triggerIndex, 0);
			}
	
	Mover(PApplet p, ArrayList<Mover> listMovers, ArrayList<PImage> images,
			PVector position, float rotation, boolean diesInTheEnd,
			boolean isFritz, int triggerIndex, float trigger) 
		{
		this.p = p;
		this.listMovers = listMovers;
		this.images = images;
		this.position = position;
		this.rotation = rotation;
		this.diesInTheEnd = diesInTheEnd;
		this.trigger = trigger;
		this.isPlayer = isFritz;
		this.triggerIndex = triggerIndex;
		this.isFritz = isFritz;
		
		startImage = images.get(0);
		endImage = images.get(images.size() - 1);

		delta = new PVector();

		isKiller = false;
		
		pointer = new Pointer(p, new PVector(0, -40));
		
		this.stateMachine = new MoverStateMachine(p, this);
	}
		
	/****************************************
	 *    			Draw cycle
	 ****************************************/
	
	public void click()
	{
		this.stateMachine.click();
	}
	
	void update() 
	{
		this.stateMachine.update();
	}
	
	public void draw()
	{
		this.stateMachine.draw();
		
		if (shouldDrawPointer && isFritz)
		{
			p.pushMatrix();
			p.translate(position.x, position.y);
			pointer.draw();
			p.popMatrix();
		}
	}

	void moveToPosition(PVector destination, float duration) {
		isKiller = true;

		PVector directionVector = PVector.sub(destination, position);
		float velocity = directionVector.mag() / (duration * p.frameRate);
		directionVector.normalize();
		delta = PVector.mult(directionVector, velocity);
	}
	
	public boolean isCollidable()
	{
		return stateMachine.isCollidable();
	}
	
}
