package ro.tibor.processing.gameJam;

import java.util.ArrayList;

import processing.core.PApplet;
import processing.core.PImage;
import processing.core.PVector;

public class Pointer 
{
	
	/****************************************
	 *    			Attributes
	 ****************************************/
	
	PApplet p;
	ArrayList<PImage> images;
	int index;
	PVector position;
		
	/****************************************
	 *    			Constructor
	 ****************************************/
	
	Pointer(PApplet p, PVector position) 
	{
		this.p = p;
		images = new ArrayList<PImage>();
		index = 0;
		this.position = position;
		
		for (int i = 0; i < 4; i++) 
		{
			//images.add(p.loadImage("pointer/" + i + ".png"));
			images.add(p.loadImage("pointer/P1 " + (i + 1) + ".png"));
		}
	}
	
	/****************************************
	 *    			Draw cycle
	 ****************************************/
	
	void draw()
	{
		p.pushMatrix();
		p.translate(position.x, position.y);
		if (p.frameCount % 5 == 0)
		{
			index = (index + 1) % (images.size() - 1);
		}
		p.image(images.get(index), 0, 0);
		p.popMatrix();
	}
}
