package ro.tibor.processing.gameJam.stateMachine;

import processing.core.PApplet;
import processing.core.PVector;
import ro.tibor.processing.gameJam.AudioManager;
import ro.tibor.processing.gameJam.Mover;

public class MoverStateIdle extends MoverState 
{
	
	private int index;
	
	public MoverStateIdle(Mover mover, PApplet p) 
	{
		super(mover, p);
		// TODO Auto-generated constructor stub
	}
	
	@Override
	void start() 
	{
		super.start();
		mover.shouldDrawPointer = true;
	}
	
	void click()
	{
		this.mover.stateMachine.next();
	}
	
	@Override
	void update() 
	{
		super.update();
				
		if (mover.triggerIndex == 0)
		{
			index = 0;
		}
		else
		{
			index = (index + 1) % mover.triggerIndex;
		}
				
		PVector position = mover.listPositions.get(index);
		Float rotation = mover.listRotations.get(index);
				
		mover.position = position;
		mover.rotation = rotation;
		
		checkCollision();
	}
	
	@Override
	void checkCollision() 
	{
		super.checkCollision();
		
		// TODO rock paper scissors killing
		for (Mover m: mover.listMovers)
		{
			float distance = PVector.dist(mover.position, m.position);

			if (distance < mover.startImage.width && m != mover && !mover.isFritz)
			{
				mover.stateMachine.setStateDead();
				AudioManager.getInstance().playDeathSound();
			}
		}		
	}
}
