package ro.tibor.processing.gameJam.stateMachine;

import processing.core.PApplet;
import ro.tibor.processing.gameJam.Mover;

public class MoverStateMachine 
{

	private Mover mover;
	private PApplet p;
	private MoverState[] states;
	private int current = 0;
	
	public MoverStateMachine(PApplet p, Mover mover) 
	{
		this.p = p;
		this.mover = mover;
		states = new MoverState[]{
				new MoverStatePast(mover, p),    // 0
				new MoverStateFuture(mover, p),  // 1
				new MoverStatePresent(mover, p), // 2
				new MoverStateMoving(mover, p),  // 3
				new MoverStateDead(mover, p),    // 4
				new MoverStateIdle(mover, p)     // 5 
				};
	}
	
	/*public void setStateMoving()
	{
		this.setState(3);
	}*/
	
	public void setStateDead()
	{
		this.setState(4);
	}
	
	public void next() 
	{
		if (current == 2 && mover.isFritz)
		{
			this.setState(5);
		}
		else if (current == 5)
		{
			this.setState(3); // Moving
		}
		else
		{
			this.setState(current + 1);
		}
	}
	
	public void setState(int state)
	{
		current = PApplet.constrain(state, 0, states.length - 1);
		states[current].start();
	}
	
	public void update()
	{
		states[current].update();
	}
	
	public void click()
	{
		states[current].click();
	}
	
	public void draw() 
	{
		states[current].draw();
	}
	
	public boolean isCollidable()
	{
		return current == 2 || current == 3 || current == 5;
	}
}
