package ro.tibor.processing.gameJam.stateMachine;

import processing.core.PApplet;
import processing.core.PVector;
import ro.tibor.processing.gameJam.AudioManager;
import ro.tibor.processing.gameJam.Mover;

public class MoverStateMoving extends MoverState
{
	private boolean isAnimating;
	private int index = 0;
	
	public MoverStateMoving(Mover mover, PApplet p) 
	{
		super(mover, p);
		// TODO Auto-generated constructor stub
	}
	
	@Override
	void start() 
	{
		super.start();
		isAnimating = true;
		index = 0;
		if (mover.isFritz)
		{
			index = mover.triggerIndex;
		}
		mover.shouldDrawPointer = true;
	}
	
	@Override
	void update() 
	{
		super.update();
				
		PVector position = mover.listPositions.get(index);
		Float rotation = mover.listRotations.get(index);
		
		index = PApplet.constrain(index + 1, 0, mover.listRotations.size() - 1);
		
		mover.position = position;
		mover.rotation = rotation;
		
		checkCollision();
	}
	
	@Override
	void checkCollision() 
	{
		super.checkCollision();
		
		// TODO rock paper scissors killing
		for (Mover m: mover.listMovers)
		{
			float distance = PVector.dist(mover.position, m.position);

			if (distance < mover.startImage.width && m != mover && !mover.isFritz)
			{
				mover.stateMachine.setStateDead();
				AudioManager.getInstance().playDeathSound();
			}
		}		
	}
	
	@Override
	void customDraw() 
	{
		p.image(mover.images.get(0), 0, 0);
	}

}
