package ro.tibor.processing.gameJam.stateMachine;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Timer;

import processing.core.PApplet;
import processing.core.PVector;
import ro.tibor.processing.gameJam.AudioManager;
import ro.tibor.processing.gameJam.Mover;

public class MoverStatePresent extends MoverState
{

	public MoverStatePresent(Mover mover, PApplet p) {
		super(mover, p);
	}
	
	/**
	 * Starts the animation start point
	 */
	@Override
	void start() 
	{
		super.start();
		mover.isDead = false;
		
		mover.position = mover.listPositions.get(0);
		mover.rotation = mover.listRotations.get(0).floatValue();
		
		Timer t = new Timer((int)(mover.trigger * 1000), new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) 
			{
				mover.stateMachine.next();
				//mover.stateMachine.setStateMoving();
			}
		});
		
		t.setRepeats(false);
		t.start();
	}
	
	@Override
	void customDraw() 
	{
		p.image(mover.images.get(0), 0, 0);
	}
	
	@Override
	void update() 
	{
		super.update();
		checkCollision();
	}
	
	@Override
	void checkCollision() 
	{
		super.checkCollision();
		
		for (Mover m: mover.listMovers)
		{
			float distance = PVector.dist(mover.position, m.position);

			if (distance < mover.startImage.width && m != mover && !mover.isFritz)
			{
				mover.stateMachine.setStateDead();
				AudioManager.getInstance().playDeathSound();
			}
		}
	}
}
